#! /bin/sh

if [ $# -lt 2 ]; then
  cat <<-EOF
	Usage: $0 SOURCE RETURN_TYPE [ARG1_TYPE ...]
EOF
  exit 1
fi
set -f # Disable pathname expansion.
s=" *"
w="[a-zA-Z0-9_]+"
src=$1
shift
pattern="^${s}(extern |)${1} ${w}${s}[(]"
shift
sep="$s"
while [ $# -gt 0 ]; do
  x=$(echo $1 | sed 's/[ 	][ 	]*\*/ *\\*/g')
  case "$1" in
    *[*]) pattern="${pattern}${sep}${x}${s}${w}" ;;
    *)    pattern="${pattern}${sep}${x} ${w}" ;;
  esac
  sep="${s},${s}"
  shift
done

echo "$pattern"

sed <$src 's,[ 	][ 	]*, ,g' | egrep "$pattern"
